#!/bin/python3

import glob
import os

from sys import argv

name = argv[1]
delay = int(argv[2])

gnuStyle = "plot"

print("\n----\nWriting gnuplot commands.")
gpCmd = open("commands", "w")

gpCmd.write("set term png size 1024,1024\n")
gpCmd.write("set boxwidth 0.5\n")
gpCmd.write("set style fill solid\n")


for file in glob.glob('guests*.dat'):
	file = file[:-4]
	gpCmd.write('set output "{0}.png"\n'.format(file))

	gpCmd.write('{0} [0:20] [0:4200] "{1}.dat" with boxes\n'
			.format(gnuStyle, file))

gpCmd.close()



print("\n----\nRunning gnuplot.")
os.system("gnuplot commands")



print("\n----\nCreating the gif.")
os.system("convert -delay {0} -loop 0 *.png {1}.gif".format(delay, name))
print("{0}.gif".format(name))



print("\n----\nCleaning up.\n\n")
os.system("rm *.png commands")